%ROF_TEST This function is a test function for the SplitBregman
%implementations for 2D

scaling = 255; % select the data range [0 scaling], e.g. [0 255].

%% Get the test image
% read 2D test data
filename = 'cameraman'; ext = '.tif';
exact = imread([filename ext]);
% convert RGB to grayscale
if size(size(exact),2) == 3
    exact = rgb2gray(exact);
end
exact = single(exact);
exact = imresize(exact,2);
exact = exact-min(exact(:));
exact = exact/max(exact(:));
[nx ny] = size(exact); nz = 1;
        
% add noise
variance = 0.01; mean = 0;
f = exact+sqrt(variance)*randn(nx,ny,nz) + mean;
f = f-min(f(:));
f = scaling*f/max(f(:));

%% Denoise the Image
mu = 10/scaling; % parameter in front of the data fidelity (inverse of regularization parameter)
tol = 1e-4; maxIts = 1000;

% C implementation in 2D
% Ths code should have been compiled using the "mex" command once before this code can work:
DEBUG = 0;      % use debugging for c-code compiling or not
compile_mex('SplitBregmanROF',DEBUG);
%profile on;
tic;
[u alg_error its] = SplitBregmanROF(double(f),mu,tol,maxIts);
toc;
%profile off; profile viewer;
alg_error
its

%% Display Results
figure;
subplot(2,2,1); imagesc(exact); colormap(gray); colorbar; title('Original');
subplot(2,2,2); imagesc(f); colormap(gray); colorbar; title('f');
subplot(2,2,3); imagesc(u); colormap(gray); colorbar; title('denoised');
subplot(2,2,4); imagesc(f-u); colormap(gray); colorbar; title('difference');